---
title: XMLHttpRequest.send()
slug: Web/API/XMLHttpRequest/send
tags:
  - AJAX
  - API
  - HTTP request
  - Method
  - NeedsContent
  - NeedsExample
  - Reference
  - XHR
  - XHR Request
  - XMLHttpRequest
  - send
---
<div>{{APIRef('XMLHttpRequest')}}</div>

<p><span class="seoSummary">The {{domxref("XMLHttpRequest")}} method <code><strong>send()</strong></code> sends the request to the server.</span> If the request is asynchronous (which is the default), this method returns as soon as the request is sent and the result is delivered using events. If the request is synchronous, this method doesn't return until the response has arrived.</p>

<p><code>send()</code> accepts an optional parameter which lets you specify the request's body; this is primarily used for requests such as {{HTTPMethod("PUT")}}. If the request method is {{HTTPMethod("GET")}} or {{HTTPMethod("HEAD")}}, the <code>body</code> parameter is ignored and the request body is set to <code>null</code>.</p>

<p>If no {{HTTPHeader("Accept")}} header has been set using the {{domxref("XMLHttpRequest.setRequestHeader", "setRequestHeader()")}}, an <code>Accept</code> header with the type <code>"*/*"</code> (any type) is sent.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>XMLHttpRequest</var>.send(<var>body</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>body</code> {{optional_inline}}</dt>
 <dd>A body of data to be sent in the XHR request. This can be:
 <ul>
  <li>A {{domxref("Document")}}, in which case it is serialized before being sent.</li>
  <li>An <code>XMLHttpRequestBodyInit</code>, which <a href="https://fetch.spec.whatwg.org/#typedefdef-xmlhttprequestbodyinit">per the Fetch spec</a> can be a {{domxref("Blob")}}, {{domxref("BufferSource")}}, {{domxref("FormData")}}, {{domxref("URLSearchParams")}}, or {{domxref("USVString")}} object.</li>
  <li><code>null</code></li>
 </ul>
 If no value is specified for the body, a default value of <code>null</code> is used.</dd>
</dl>

<p>The best way to send binary content (e.g. in file uploads) is by using an {{domxref("ArrayBufferView")}} or {{domxref("Blob")}} in conjunction with the <code>send()</code> method.</p>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td><code>send()</code> has already been invoked for the request, and/or the request is complete.</td>
  </tr>
  <tr>
   <td><code>NetworkError</code></td>
   <td>The resource type to be fetched is a Blob, and the method is not <code>GET</code>.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example_GET">Example: GET</h2>

<pre class="brush: js"><code>var xhr = new XMLHttpRequest();
xhr.open('GET', '/server', true);

xhr.onload = function () {
  // Request finished. Do processing here.
};

xhr.send(null);
// xhr.send('string');
</code>// <code>xhr.send(new Blob());
// xhr.send(new Int8Array());
// xhr.send(document);</code>
</pre>

<h2 id="Example_POST">Example: POST</h2>

<pre class="brush: js"><code>var xhr = new XMLHttpRequest();
xhr.open("POST", '/server', true);

//Send the proper header information along with the request
xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");

xhr.onreadystatechange = function() { // Call a function when the state changes.
    if (this.readyState === XMLHttpRequest.DONE &amp;&amp; this.status === 200) {
        // Request finished. Do processing here.
    }
}
xhr.send("foo=bar&amp;lorem=ipsum");
// xhr.send(new Int8Array());
// xhr.send(document);</code>
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#the-send()-method', 'send()')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XMLHttpRequest.send")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/HTML_in_XMLHttpRequest">HTML in XMLHttpRequest</a></li>
</ul>
